"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class AaveUserPositionPerTokenChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class AaveUserPositionPerTokenToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class AaveUserPositionPerTokenRequestTypedDict(TypedDict):
    chain: AaveUserPositionPerTokenChain
    r"""The chain to use."""
    block: NotRequired[Nullable[int]]
    r"""Optional block number (defaults to latest)."""
    user: str
    r"""The user to fetch the token-specific position of."""
    token: AaveUserPositionPerTokenToken
    r"""The symbol of the asset to fetch the user's position on.."""


class AaveUserPositionPerTokenRequest(BaseModel):
    chain: Annotated[
        AaveUserPositionPerTokenChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = AaveUserPositionPerTokenChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        OptionalNullable[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""Optional block number (defaults to latest)."""

    user: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B"
    r"""The user to fetch the token-specific position of."""

    token: Annotated[
        AaveUserPositionPerTokenToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = AaveUserPositionPerTokenToken.USDC
    r"""The symbol of the asset to fetch the user's position on.."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["block"]
        nullable_fields = ["block"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
