"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .signedauthorization import SignedAuthorization, SignedAuthorizationTypedDict
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from typing import Union
from typing_extensions import TypeAliasType, TypedDict


CollateralAmountTypedDict = TypeAliasType(
    "CollateralAmountTypedDict", Union[float, str]
)
r"""Amount of collateral token to supply to Aave"""


CollateralAmount = TypeAliasType("CollateralAmount", Union[float, str])
r"""Amount of collateral token to supply to Aave"""


class AaveLoopRequestTypedDict(TypedDict):
    r"""Request model for executing an Aave loop strategy."""

    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    signed_authorization: SignedAuthorizationTypedDict
    collateral_token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    borrow_token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    collateral_amount: CollateralAmountTypedDict
    r"""Amount of collateral token to supply to Aave"""
    loop_count: int
    r"""Number of times to perform the supply-borrow loop"""
    max_slippage_percent: float
    r"""Maximum allowed slippage for token swaps in percentage"""
    loan_to_value: float
    r"""Loan To Value percentage of the loop"""


class AaveLoopRequest(BaseModel):
    r"""Request model for executing an Aave loop strategy."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    signed_authorization: SignedAuthorization

    collateral_token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    borrow_token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    collateral_amount: CollateralAmount
    r"""Amount of collateral token to supply to Aave"""

    loop_count: int
    r"""Number of times to perform the supply-borrow loop"""

    max_slippage_percent: float
    r"""Maximum allowed slippage for token swaps in percentage"""

    loan_to_value: float
    r"""Loan To Value percentage of the loop"""
