"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from typing_extensions import TypedDict


class AaveUserPositionPerTokenResponseTypedDict(TypedDict):
    token_balance: str
    r"""The balance of AAVE aTokens (interest-bearing representations of your deposits)."""
    stable_debt: str
    r"""The amount of the user's debt with a fixed interest rate."""
    variable_debt: str
    r"""The amount of the user's debt with a variable interest rate."""
    principal_stable_debt: str
    r"""The amount of the user's debt that was part of the initial principal of all
    loans with a stable interest rate.
    """
    principal_variable_debt: str
    r"""The amount of the user's debt that was part of the initial principal of all
    loans with a variable interest rate. This is the value stored by AAVE, which may be slightly
    inaccurate, but reflects what AAVE believes you initially paid.
    """
    stable_borrow_rate: str
    r"""The current average annualised interest rate for all your stable loans in
    this pool.
    """
    stable_borrow_rate_for_new_loans: str
    r"""The annualised interest rate you would pay on a new stable loan."""
    variable_borrow_rate: str
    r"""The current annualised interest rate for variable rate loans in this pool.
    (This applies to both current and new loans.)
    """
    liquidity_rate: str
    r"""The annualised interest rate for deposited supplies."""


class AaveUserPositionPerTokenResponse(BaseModel):
    token_balance: str
    r"""The balance of AAVE aTokens (interest-bearing representations of your deposits)."""

    stable_debt: str
    r"""The amount of the user's debt with a fixed interest rate."""

    variable_debt: str
    r"""The amount of the user's debt with a variable interest rate."""

    principal_stable_debt: str
    r"""The amount of the user's debt that was part of the initial principal of all
    loans with a stable interest rate.
    """

    principal_variable_debt: str
    r"""The amount of the user's debt that was part of the initial principal of all
    loans with a variable interest rate. This is the value stored by AAVE, which may be slightly
    inaccurate, but reflects what AAVE believes you initially paid.
    """

    stable_borrow_rate: str
    r"""The current average annualised interest rate for all your stable loans in
    this pool.
    """

    stable_borrow_rate_for_new_loans: str
    r"""The annualised interest rate you would pay on a new stable loan."""

    variable_borrow_rate: str
    r"""The current annualised interest rate for variable rate loans in this pool.
    (This applies to both current and new loans.)
    """

    liquidity_rate: str
    r"""The annualised interest rate for deposited supplies."""
