"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


AerodromeSlipstreamBuyExactlyParamsAmountOutTypedDict = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyParamsAmountOutTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


AerodromeSlipstreamBuyExactlyParamsAmountOut = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyParamsAmountOut", Union[float, str]
)
r"""The amount of the token to swap to"""


AerodromeSlipstreamBuyExactlyParamsAmountInMaximumTypedDict = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyParamsAmountInMaximumTypedDict", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


AerodromeSlipstreamBuyExactlyParamsAmountInMaximum = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyParamsAmountInMaximum", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


class AerodromeSlipstreamBuyExactlyParamsTypedDict(TypedDict):
    r"""Parameters model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    tick_spacing: int
    r"""The tick spacing of the pool"""
    amount_out: AerodromeSlipstreamBuyExactlyParamsAmountOutTypedDict
    r"""The amount of the token to swap to"""
    amount_in_maximum: AerodromeSlipstreamBuyExactlyParamsAmountInMaximumTypedDict
    r"""The maximum amount of the token to swap from"""
    action_type: Literal["AERODROME_SLIPSTREAM_BUY_EXACTLY"]


class AerodromeSlipstreamBuyExactlyParams(BaseModel):
    r"""Parameters model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    tick_spacing: int
    r"""The tick spacing of the pool"""

    amount_out: AerodromeSlipstreamBuyExactlyParamsAmountOut
    r"""The amount of the token to swap to"""

    amount_in_maximum: AerodromeSlipstreamBuyExactlyParamsAmountInMaximum
    r"""The maximum amount of the token to swap from"""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["AERODROME_SLIPSTREAM_BUY_EXACTLY"]],
            AfterValidator(validate_const("AERODROME_SLIPSTREAM_BUY_EXACTLY")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "AERODROME_SLIPSTREAM_BUY_EXACTLY"
