"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


AerodromeSlipstreamBuyExactlyRequestAmountOutTypedDict = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyRequestAmountOutTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


AerodromeSlipstreamBuyExactlyRequestAmountOut = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyRequestAmountOut", Union[float, str]
)
r"""The amount of the token to swap to"""


AerodromeSlipstreamBuyExactlyRequestAmountInMaximumTypedDict = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyRequestAmountInMaximumTypedDict", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


AerodromeSlipstreamBuyExactlyRequestAmountInMaximum = TypeAliasType(
    "AerodromeSlipstreamBuyExactlyRequestAmountInMaximum", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


class AerodromeSlipstreamBuyExactlyRequestTypedDict(TypedDict):
    r"""Request model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    tick_spacing: int
    r"""The tick spacing of the pool"""
    amount_out: AerodromeSlipstreamBuyExactlyRequestAmountOutTypedDict
    r"""The amount of the token to swap to"""
    amount_in_maximum: AerodromeSlipstreamBuyExactlyRequestAmountInMaximumTypedDict
    r"""The maximum amount of the token to swap from"""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["AERODROME_SLIPSTREAM_BUY_EXACTLY"]


class AerodromeSlipstreamBuyExactlyRequest(BaseModel):
    r"""Request model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    tick_spacing: int
    r"""The tick spacing of the pool"""

    amount_out: AerodromeSlipstreamBuyExactlyRequestAmountOut
    r"""The amount of the token to swap to"""

    amount_in_maximum: AerodromeSlipstreamBuyExactlyRequestAmountInMaximum
    r"""The maximum amount of the token to swap from"""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["AERODROME_SLIPSTREAM_BUY_EXACTLY"]],
            AfterValidator(validate_const("AERODROME_SLIPSTREAM_BUY_EXACTLY")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "AERODROME_SLIPSTREAM_BUY_EXACTLY"
