"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GenericAllowanceChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class GenericAllowanceToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class GenericAllowanceContractName(str, Enum):
    r"""The name of the contract to check allowance for."""

    AAVE_V3_POOL = "AaveV3Pool"
    AERODROME_BASIC_ROUTER = "AerodromeBasicRouter"
    AERODROME_SLIPSTREAM_ROUTER = "AerodromeSlipstreamRouter"
    AERODROME_SLIPSTREAM_NONFUNGIBLE_POSITION_MANAGER = (
        "AerodromeSlipstreamNonfungiblePositionManager"
    )
    UNISWAP_V3_ROUTER = "UniswapV3Router"
    UNISWAP_V3_NFT_POSITION_MANAGER = "UniswapV3NFTPositionManager"
    MORPHO = "Morpho"
    SKY_DAI_USDS_CONVERTER = "SkyDaiUsdsConverter"
    SKY_USDC_USDS_CONVERTER = "SkyUsdcUsdsConverter"
    SKY_USDS_VAULT = "SkyUsdsVault"
    PENDLE_ROUTER = "PendleRouter"


class GenericAllowanceRequestTypedDict(TypedDict):
    chain: GenericAllowanceChain
    r"""The chain to use."""
    block: NotRequired[Nullable[int]]
    r"""Optional block number (defaults to latest)."""
    user: NotRequired[str]
    r"""The user to get the ERC20 allowance of."""
    token: GenericAllowanceToken
    r"""The symbol of the token for which the allowance is checked.."""
    contract_name: GenericAllowanceContractName
    r"""The name of the contract to check allowance for."""


class GenericAllowanceRequest(BaseModel):
    chain: Annotated[
        GenericAllowanceChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = GenericAllowanceChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        OptionalNullable[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""Optional block number (defaults to latest)."""

    user: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B"
    r"""The user to get the ERC20 allowance of."""

    token: Annotated[
        GenericAllowanceToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = GenericAllowanceToken.USDC
    r"""The symbol of the token for which the allowance is checked.."""

    contract_name: Annotated[
        GenericAllowanceContractName,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = GenericAllowanceContractName.AAVE_V3_POOL
    r"""The name of the contract to check allowance for."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["block", "user"]
        nullable_fields = ["block"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
