"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class MorphoVaultPositionChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


class MorphoVaultPositionRequestTypedDict(TypedDict):
    chain: MorphoVaultPositionChain
    block: NotRequired[Nullable[int]]
    r"""Optional block number (defaults to latest)."""
    user_address: str
    r"""The user address of the desired vault position."""
    vault_address: str
    r"""The vault address of the desired vault position."""


class MorphoVaultPositionRequest(BaseModel):
    chain: Annotated[
        MorphoVaultPositionChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoVaultPositionChain.ETHEREUM_MAINNET

    block: Annotated[
        OptionalNullable[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""Optional block number (defaults to latest)."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xa829B388A3DF7f581cE957a95edbe419dd146d1B"
    r"""The user address of the desired vault position."""

    vault_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xbEef047a543E45807105E51A8BBEFCc5950fcfBa"
    r"""The vault address of the desired vault position."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["block"]
        nullable_fields = ["block"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
