"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import validate_const
from enum import Enum
import pydantic
from pydantic import model_serializer
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


MorphoSupplyCollateralRequestAmountTypedDict = TypeAliasType(
    "MorphoSupplyCollateralRequestAmountTypedDict", Union[float, str]
)
r"""Amount of the token to supply to the market as collateral."""


MorphoSupplyCollateralRequestAmount = TypeAliasType(
    "MorphoSupplyCollateralRequestAmount", Union[float, str]
)
r"""Amount of the token to supply to the market as collateral."""


class MorphoSupplyCollateralRequestChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


class MorphoSupplyCollateralRequestTypedDict(TypedDict):
    amount: MorphoSupplyCollateralRequestAmountTypedDict
    r"""Amount of the token to supply to the market as collateral."""
    unique_market_key: str
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""
    chain: MorphoSupplyCollateralRequestChain
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["MORPHO_SUPPLY_COLLATERAL"]
    on_behalf_of: NotRequired[Nullable[str]]
    r"""The address on behalf of whom the supplied collateral is made. Defaults to sender."""
    callback_data: NotRequired[Nullable[bytes]]
    r"""An optional field for callback byte data that will be triggered upon successful supplying of collateral."""


class MorphoSupplyCollateralRequest(BaseModel):
    amount: MorphoSupplyCollateralRequestAmount
    r"""Amount of the token to supply to the market as collateral."""

    unique_market_key: str
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""

    chain: MorphoSupplyCollateralRequestChain

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["MORPHO_SUPPLY_COLLATERAL"]],
            AfterValidator(validate_const("MORPHO_SUPPLY_COLLATERAL")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "MORPHO_SUPPLY_COLLATERAL"

    on_behalf_of: OptionalNullable[str] = UNSET
    r"""The address on behalf of whom the supplied collateral is made. Defaults to sender."""

    callback_data: OptionalNullable[bytes] = UNSET
    r"""An optional field for callback byte data that will be triggered upon successful supplying of collateral."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["action_type", "on_behalf_of", "callback_data"]
        nullable_fields = ["on_behalf_of", "callback_data"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
