"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


PendleSellPtRequestAmountTypedDict = TypeAliasType(
    "PendleSellPtRequestAmountTypedDict", Union[float, str]
)
r"""The amount of market's Principal Token (PT) you would like to sell for market's Underlying Token."""


PendleSellPtRequestAmount = TypeAliasType(
    "PendleSellPtRequestAmount", Union[float, str]
)
r"""The amount of market's Principal Token (PT) you would like to sell for market's Underlying Token."""


class PendleSellPtRequestTypedDict(TypedDict):
    market_address: str
    r"""The address of the market identifying which Principal Token (PT) you would like to sell."""
    amount: PendleSellPtRequestAmountTypedDict
    r"""The amount of market's Principal Token (PT) you would like to sell for market's Underlying Token."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["PENDLE_SELL_PT"]


class PendleSellPtRequest(BaseModel):
    market_address: str
    r"""The address of the market identifying which Principal Token (PT) you would like to sell."""

    amount: PendleSellPtRequestAmount
    r"""The amount of market's Principal Token (PT) you would like to sell for market's Underlying Token."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["PENDLE_SELL_PT"]],
            AfterValidator(validate_const("PENDLE_SELL_PT")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "PENDLE_SELL_PT"
