"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .token_enum import TokenEnum
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class ReserveTypedDict(TypedDict):
    symbol: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    name: str
    r"""Name of Token"""
    underlying_asset: str
    r"""Checksum address of Token."""
    decimals: NotRequired[Nullable[int]]
    r"""Number of decimals of token."""


class Reserve(BaseModel):
    symbol: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    name: str
    r"""Name of Token"""

    underlying_asset: Annotated[str, pydantic.Field(alias="underlyingAsset")]
    r"""Checksum address of Token."""

    decimals: OptionalNullable[int] = UNSET
    r"""Number of decimals of token."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["decimals"]
        nullable_fields = ["decimals"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
