"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing import Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class UniswapQuoteSellExactlyChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class UniswapQuoteSellExactlyTokenInToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class UniswapQuoteSellExactlyTokenOutToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class UniswapQuoteSellExactlyFeeEnum(str, Enum):
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    ZERO_DOT_01 = "0.01"
    ZERO_DOT_05 = "0.05"
    ZERO_DOT_3 = "0.3"
    ONE_DOT_0 = "1.0"


UniswapQuoteSellExactlyAmountInTypedDict = TypeAliasType(
    "UniswapQuoteSellExactlyAmountInTypedDict", Union[float, str]
)
r"""The amount of the token to swap from"""


UniswapQuoteSellExactlyAmountIn = TypeAliasType(
    "UniswapQuoteSellExactlyAmountIn", Union[float, str]
)
r"""The amount of the token to swap from"""


class UniswapQuoteSellExactlyRequestTypedDict(TypedDict):
    amount_in: UniswapQuoteSellExactlyAmountInTypedDict
    r"""The amount of the token to swap from"""
    chain: UniswapQuoteSellExactlyChain
    r"""The chain to use."""
    block: NotRequired[Nullable[int]]
    r"""Optional block number (defaults to latest)."""
    token_in: UniswapQuoteSellExactlyTokenInToken
    r"""The symbol of the token to swap from."""
    token_out: UniswapQuoteSellExactlyTokenOutToken
    r"""The symbol of the token to swap to."""
    fee: UniswapQuoteSellExactlyFeeEnum
    r"""The fee to pay for the swap"""


class UniswapQuoteSellExactlyRequest(BaseModel):
    amount_in: Annotated[
        UniswapQuoteSellExactlyAmountIn,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ]
    r"""The amount of the token to swap from"""

    chain: Annotated[
        UniswapQuoteSellExactlyChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteSellExactlyChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        OptionalNullable[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""Optional block number (defaults to latest)."""

    token_in: Annotated[
        UniswapQuoteSellExactlyTokenInToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteSellExactlyTokenInToken.USDC
    r"""The symbol of the token to swap from."""

    token_out: Annotated[
        UniswapQuoteSellExactlyTokenOutToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteSellExactlyTokenOutToken.USDT
    r"""The symbol of the token to swap to."""

    fee: Annotated[
        UniswapQuoteSellExactlyFeeEnum,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteSellExactlyFeeEnum.ZERO_DOT_01
    r"""The fee to pay for the swap"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["block"]
        nullable_fields = ["block"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
