"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .signedauthorization import SignedAuthorization, SignedAuthorizationTypedDict
from compass_api_sdk.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UnsignedMulticallTransactionTypedDict(TypedDict):
    chain_id: int
    r"""The chain id of the transaction"""
    data: str
    r"""The data of the transaction"""
    from_: str
    r"""The sender of the transaction"""
    gas: int
    r"""The gas of the transaction"""
    to: str
    r"""The recipient of the transaction"""
    value: int
    r"""The value of the transaction"""
    nonce: int
    r"""The nonce of the address"""
    max_fee_per_gas: int
    r"""The max fee per gas of the transaction"""
    max_priority_fee_per_gas: int
    r"""The max priority fee per gas of the transaction"""
    authorization_list: NotRequired[List[SignedAuthorizationTypedDict]]
    r"""EIP-7702 authorization"""


class UnsignedMulticallTransaction(BaseModel):
    chain_id: Annotated[int, pydantic.Field(alias="chainId")]
    r"""The chain id of the transaction"""

    data: str
    r"""The data of the transaction"""

    from_: Annotated[str, pydantic.Field(alias="from")]
    r"""The sender of the transaction"""

    gas: int
    r"""The gas of the transaction"""

    to: str
    r"""The recipient of the transaction"""

    value: int
    r"""The value of the transaction"""

    nonce: int
    r"""The nonce of the address"""

    max_fee_per_gas: Annotated[int, pydantic.Field(alias="maxFeePerGas")]
    r"""The max fee per gas of the transaction"""

    max_priority_fee_per_gas: Annotated[
        int, pydantic.Field(alias="maxPriorityFeePerGas")
    ]
    r"""The max priority fee per gas of the transaction"""

    authorization_list: Annotated[
        Optional[List[SignedAuthorization]], pydantic.Field(alias="authorizationList")
    ] = None
    r"""EIP-7702 authorization"""
