"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


WrapEthRequestAmountTypedDict = TypeAliasType(
    "WrapEthRequestAmountTypedDict", Union[float, str]
)
r"""The amount of ETH to wrap."""


WrapEthRequestAmount = TypeAliasType("WrapEthRequestAmount", Union[float, str])
r"""The amount of ETH to wrap."""


class WrapEthRequestTypedDict(TypedDict):
    r"""Request model for wrapping ETH into WETH."""

    amount: WrapEthRequestAmountTypedDict
    r"""The amount of ETH to wrap."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["WRAP_ETH"]


class WrapEthRequest(BaseModel):
    r"""Request model for wrapping ETH into WETH."""

    amount: WrapEthRequestAmount
    r"""The amount of ETH to wrap."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["WRAP_ETH"]], AfterValidator(validate_const("WRAP_ETH"))
        ],
        pydantic.Field(alias="action_type"),
    ] = "WRAP_ETH"
